org.apache.tomcat.util.bcel.classfile

## Class ElementValue

- java.lang.Object
- - org.apache.tomcat.util.bcel.classfile.ElementValue

Direct Known Subclasses:
  AnnotationElementValue, ArrayElementValue, ClassElementValue, EnumElementValue, SimpleElementValue

    public abstract class ElementValue
    extends Object

Since:
  6.0
Author:
  D. Brosius

### Field Summary

Fields
`static int` `ANNOTATION`
`static int` `ARRAY`
`static int` `CLASS`
`protected ConstantPool` `cpool`
`static int` `ENUM_CONSTANT`
`static int` `PRIMITIVE_BOOLEAN`
`static int` `PRIMITIVE_BYTE`
`static int` `PRIMITIVE_CHAR`
`static int` `PRIMITIVE_DOUBLE`
`static int` `PRIMITIVE_FLOAT`
`static int` `PRIMITIVE_INT`
`static int` `PRIMITIVE_LONG`
`static int` `PRIMITIVE_SHORT`
`static int` `STRING`
`protected int` `type`

### Constructor Summary

Constructors
`protected` `ElementValue(int type, ConstantPool cpool)`

### Method Summary

Methods
`abstract void` `dump(DataOutputStream dos)`
`static ElementValue` `readElementValue(DataInputStream dis, ConstantPool cpool)`
`abstract String` `stringifyValue()`
`String` `toString()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### type

    protected int type

#### cpool

    protected ConstantPool cpool

#### STRING

    public static final int STRING

See Also:
  Constant Field Values

#### ENUM_CONSTANT

    public static final int ENUM_CONSTANT

See Also:
  Constant Field Values

#### CLASS

    public static final int CLASS

See Also:
  Constant Field Values

#### ANNOTATION

    public static final int ANNOTATION

See Also:
  Constant Field Values

#### ARRAY

    public static final int ARRAY

See Also:
  Constant Field Values

#### PRIMITIVE_INT

    public static final int PRIMITIVE_INT

See Also:
  Constant Field Values

#### PRIMITIVE_BYTE

    public static final int PRIMITIVE_BYTE

See Also:
  Constant Field Values

#### PRIMITIVE_CHAR

    public static final int PRIMITIVE_CHAR

See Also:
  Constant Field Values

#### PRIMITIVE_DOUBLE

    public static final int PRIMITIVE_DOUBLE

See Also:
  Constant Field Values

#### PRIMITIVE_FLOAT

    public static final int PRIMITIVE_FLOAT

See Also:
  Constant Field Values

#### PRIMITIVE_LONG

    public static final int PRIMITIVE_LONG

See Also:
  Constant Field Values

#### PRIMITIVE_SHORT

    public static final int PRIMITIVE_SHORT

See Also:
  Constant Field Values

#### PRIMITIVE_BOOLEAN

    public static final int PRIMITIVE_BOOLEAN

See Also:
  Constant Field Values

### Constructor Detail

#### ElementValue

    protected ElementValue(int type,
                ConstantPool cpool)

### Method Detail

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

#### stringifyValue

    public abstract String stringifyValue()

#### dump

    public abstract void dump(DataOutputStream dos)
                       throws IOException

Throws:
  `IOException`

#### readElementValue

    public static ElementValue readElementValue(DataInputStream dis,
                                ConstantPool cpool)
                                         throws IOException

Throws:
  `IOException`